

   MEMBER('PYTEST.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('PYTEST003.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!!  
!!! </summary>
RunExcel PROCEDURE 

FileName             CSTRING(260)                          !  Excel
PythonProgram        CSTRING(2000)                         !   
P                    CLASS(PyClass)                        ! 
                     END                                   ! 
Window               WINDOW(' Excel'),AT(,,353,188),FONT('MS Sans Serif',8,,FONT:regular),GRAY,MDI,SYSTEM
                       PROMPT(' Excel'),AT(12,7),USE(?Prompt1)
                       ENTRY(@s255),AT(60,6,228,12),USE(FileName)
                       BUTTON('...'),AT(292,6,12,12),USE(?LookupFile)
                       TEXT,AT(12,26,324,126),USE(PythonProgram),FONT('Fixedsys',10,,FONT:regular,CHARSET:CYRILLIC), |
  VSCROLL,BOXED,FLAT
                       BUTTON(''),AT(228,158,48,19),USE(?Button3)
                       BUTTON(''),AT(292,158,48,19),USE(?Close)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
FileLookup2          SelectFileClass
CS  Cstr

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('RunExcel')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Prompt1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('RunExcel',Window)                          ! Restore window settings from non-volatile store
  FileLookup2.Init
  FileLookup2.ClearOnCancel = True
  FileLookup2.Flags=BOR(FileLookup2.Flags,FILE:LongName)   ! Allow long filenames
  FileLookup2.SetMask(' Excel','*.xls')               ! Set the file mask
  FileLookup2.WindowTitle='  '
  Cs.LoadFromFile('Excel.py')
  PythonProgram=Cs.S
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('RunExcel',Window)                       ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LookupFile
      ThisWindow.Update()
      FileName = FileLookup2.Ask(0)
      DISPLAY
    OF ?Button3
      ThisWindow.Update()
          If FileName<>'' And Exists(FileName)
            P.Set('FileName',P._String(FileName))
          Else
            P.Set('FileName',P._String(''))
          End
          IF P.Evaluate(PythonProgram)
             Message(P.Error())
          END    
            
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!!   
!!! </summary>
Database PROCEDURE 

P       Class(PyClass)
        End
Loc:DSN              CSTRING(200)                          ! Dataset
Loc:Host             CSTRING(80)                           ! 
Loc:UserName         CSTRING(32)                           ! 
Loc:Password         CSTRING(20)                           ! 
Loc:Database         CSTRING(64)                           !  
Loc:SQLRequest       CSTRING(2000)                         ! SQL-
Loc:Info             QUEUE,PRE(Info)                       !   
Name                 CSTRING(32)                           !  
Type                 CSTRING(32)                           ! 
F3                   CSTRING(32)                           ! 
F4                   CSTRING(32)                           ! 
F5                   CSTRING(32)                           ! 
F6                   CSTRING(32)                           ! 
F7                   CSTRING(32)                           ! 
                     END                                   ! 
CS                   CLASS(Cstr)                           ! 
                     END                                   ! 
PythonProg           CSTRING(2000)                         !   
Window               WINDOW('   '),AT(,,497,267),FONT('MS Sans Serif',8,,FONT:regular),RESIZE, |
  GRAY,MDI,SYSTEM
                       PROMPT('Loc : Host:'),AT(24,2),USE(?Loc:Host:Prompt)
                       ENTRY(@s79),AT(84,1,136,13),USE(Loc:Host),MSG(''),TIP('')
                       PROMPT('Loc : DSN:'),AT(236,2),USE(?Loc:DSN:Prompt)
                       ENTRY(@s199),AT(300,2,,12),USE(Loc:DSN),MSG('Dataset'),TIP('Dataset')
                       PROMPT('Loc : User Name:'),AT(24,16),USE(?Loc:UserName:Prompt)
                       ENTRY(@s31),AT(84,15,136,14),USE(Loc:UserName),MSG(''),TIP('')
                       PROMPT('Loc : Password:'),AT(24,30),USE(?Loc:Password:Prompt)
                       ENTRY(@s19),AT(84,28,,12),USE(Loc:Password),MSG(''),TIP('')
                       PROMPT('Loc : Database:'),AT(24,43),USE(?Loc:Database:Prompt)
                       ENTRY(@s63),AT(84,43,,12),USE(Loc:Database),MSG(' '),TIP(' ')
                       TEXT,AT(32,58,444,132),USE(PythonProg),BOXED
                       BUTTON(''),AT(444,197,45,14),USE(?Button2)
                       LIST,AT(20,200,396,50),USE(?List1),FORMAT('72L(2)|M~Name~@s31@59L(2)|M~Type~@s31@65L(2)' & |
  '|M~F 3~@s31@71L(2)|M~F 4~@s31@72L(2)|M~F 5~@s31@83L(2)|M~F 6~@s31@124L(2)|M~F 7~@s31@'), |
  FROM(Loc:Info)
                       BUTTON(''),AT(448,245,45,14),USE(?Close)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Database')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Loc:Host:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Database',Window)                          ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  Cs.LoadFromFile('db.py')
  PythonProg=Cs.S
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Database',Window)                       ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Button2
      ThisWindow.Update()
          P.Set('HOST',P._String(Loc:Host))
          P.Set('USERNAME',P._String(Loc:Username))
          P.Set('PASSWORD',P._String(Loc:password))
          P.Set('DATABASE',P._String(Loc:Database))
          P.Evaluate(PythonProg)
          P.Get('_result',Loc:Info)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!!   
!!! </summary>
CallProc PROCEDURE 

FileName             CSTRING(260)                          !  Excel
PythonProgram        CSTRING(2000)                         !   
P                    CLASS(PyClass)                        ! 
                     END                                   ! 
Loc:Res              LONG                                  ! 
Window               WINDOW('  '),AT(,,353,188),FONT('MS Sans Serif',8,,FONT:regular),GRAY, |
  MDI,SYSTEM
                       TEXT,AT(12,12,324,140),USE(PythonProgram),FONT('Fixedsys',10,,FONT:regular,CHARSET:CYRILLIC), |
  VSCROLL,BOXED,FLAT
                       BUTTON(''),AT(228,158,48,19),USE(?Button3)
                       BUTTON(''),AT(292,158,48,19),USE(?Close)
                       PROMPT(':'),AT(12,163),USE(?Loc:Res:Prompt)
                       ENTRY(@n_7),AT(48,162,44,12),USE(Loc:Res),RIGHT(1),MSG(' '),TIP(' ')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
CS  Cstr

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('CallProc')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?PythonProgram
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('CallProc',Window)                          ! Restore window settings from non-volatile store
  Cs.LoadFromFile('CallProc.py')
  PythonProgram=Cs.S
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('CallProc',Window)                       ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Button3
      ThisWindow.Update()
          P.Evaluate(PythonProgram)
          P.Get('Res',Loc:Res)
          Display()
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

