

   MEMBER('PYTEST.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('PYTEST001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('PYTEST002.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('PYTEST003.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Frame
!!! </summary>
Main PROCEDURE 

AppFrame             APPLICATION(''),AT(,,310,190),FONT('MS Sans Serif',8),RESIZE,MAX,STATUS(-1,80,120, |
  45),SYSTEM,IMM
                       MENUBAR,USE(?MENUBAR1)
                         MENU('&'),USE(?FileMenu)
                           ITEM(' '),USE(?PrintSetup),MSG('Setup Printer'),STD(STD:PrintSetup)
                           ITEM,USE(?SEPARATOR1),SEPARATOR
                           ITEM('&'),USE(?Exit),MSG(' '),STD(STD:Close)
                         END
                         MENU(''),USE(?)
                           ITEM(''),USE(?)
                           ITEM(' '),USE(?ReadFile)
                           ITEM(' Web-'),USE(?)
                           ITEM('Excel'),USE(?Excel)
                           ITEM('&  '),USE(?),DISABLE
                           ITEM('&   DLL'),USE(?DLL),DISABLE
                         END
                         MENU('&'),USE(?EditMenu)
                           ITEM('&'),USE(?Cut),MSG('    '),STD(STD:Cut)
                           ITEM('& '),USE(?Copy),MSG('    '),STD(STD:Copy)
                           ITEM('&'),USE(?Paste),MSG('   '),STD(STD:Paste)
                         END
                         MENU('&'),USE(?),MSG('   '),STD(STD:WindowList)
                           ITEM('&'),USE(?Tile),MSG('   '),STD(STD:TileWindow)
                           ITEM('&'),USE(?Cascade),MSG('  '),STD(STD:CascadeWindow)
                           ITEM('& '),USE(?Arrange),MSG('  '),STD(STD:ArrangeIcons)
                         END
                         MENU('&'),USE(?),MSG('Windows Help')
                           ITEM('&'),USE(?Helpindex),MSG('  '),STD(STD:HelpIndex)
                           ITEM('&  ...'),USE(?HelpSearch),MSG('    '),STD(STD:HelpSearch)
                           ITEM('&  '),USE(?HelpOnHelp),MSG('  '),STD(STD:HelpOnHelp)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::MENUBAR1 ROUTINE                                     ! Code for menu items on ?MENUBAR1
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu:: ROUTINE                                         ! Code for menu items on ?
  CASE ACCEPTED()
  OF ?
    Compute()
  OF ?ReadFile
    START(ParseText, 25000)
  OF ?
    START(GetUrl, 25000)
  OF ?Excel
    START(RunExcel, 25000)
  OF ?
    START(Database, 25000)
  OF ?DLL
    START(CallProc, 25000)
  END
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu:: ROUTINE                                         ! Code for menu items on ?
Menu:: ROUTINE                                      ! Code for menu items on ?

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
      AppFrame{PROP:TabBarVisible}  = False
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::MENUBAR1                                    ! Process menu items on ?MENUBAR1 menu
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::                                        ! Process menu items on ? menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::                                        ! Process menu items on ? menu
      DO Menu::                                     ! Process menu items on ? menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

