

   MEMBER('PYTEST.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('PYTEST002.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! 
!!! </summary>
Compute PROCEDURE 

PythonProgram        CSTRING(1000)                         !   
A                    REAL(1)                               ! 
B                    REAL(-5)                              ! 
C                    REAL(6)                               ! 
X1                   REAL                                  ! 
X2                   REAL                                  ! 
S                    QUEUE,PRE()                           ! 
X                    REAL                                  ! 
Val                  REAL                                  ! 
                     END                                   ! 
Window               WINDOW(''),AT(,,502,185),FONT('Microsoft Sans Serif',8,,FONT:regular),RESIZE,GRAY, |
  SYSTEM
                       PROMPT('A:'),AT(20,3),USE(?A:Prompt)
                       ENTRY(@n-10.2),AT(72,3,,12),USE(A),DECIMAL(14)
                       PROMPT('B:'),AT(128,3),USE(?B:Prompt)
                       ENTRY(@n-10.2),AT(180,3,,12),USE(B),DECIMAL(14)
                       PROMPT('C:'),AT(236,1),USE(?:Prompt)
                       ENTRY(@n-10.2),AT(288,1,,12),USE(C),DECIMAL(14)
                       TEXT,AT(16,28,344,124),USE(PythonProgram),FONT('Fixedsys',10,,FONT:regular,CHARSET:CYRILLIC), |
  VSCROLL,BOXED,FLAT
                       LIST,AT(368,26,124,124),USE(?List1),FORMAT('67R(2)|M~X~C(0)@n10.2@40R(2)|M~Sqrt(X)~C@n-12.6@'), |
  FROM(S)
                       PROMPT('X 1:'),AT(36,158),USE(?X1:Prompt)
                       ENTRY(@n10.2),AT(88,158,,12),USE(X1),DECIMAL(14)
                       PROMPT('X 2:'),AT(188,158),USE(?X2:Prompt)
                       ENTRY(@n10.2),AT(240,158,,12),USE(X2),DECIMAL(14)
                       BUTTON(''),AT(448,162,45,14),USE(?Close)
                       BUTTON(''),AT(400,162,45,14),USE(?Button2)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
P   Class(PyClass)
    End

CS  Cstr

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Compute')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?A:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Compute',Window)                           ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  Cs.LoadFromFile('Calc.py')
  PythonProgram=Cs.S
  Display()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Compute',Window)                        ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Button2
      ThisWindow.Update()
          P.Set('A',P._Real(A))
          P.Set('B',P._Real(B))
          P.Set('C',P._Real(C))
          IF P.Evaluate(PythonProgram)
            Message(P.Error(),'!') 
          ELSE   
            P.Get('S',S)
            P.Get('A',A)
            P.Get('B',B)
            P.Get('C',C)
            P.Get('X1',X1)
            P.Get('X2',X2)
          END   
          Display()
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!!    
!!! </summary>
ParseText PROCEDURE 

CS                   Cstr
P                    CLASS(PyClass)                        ! 
                     END                                   ! 
FileName             CSTRING(260)                          !  
Loc:FileName         CSTRING(260)                          !  
Loc:Message          CSTRING(61)                           ! 
PythonProgram        CSTRING(2000)                         ! 
Text                 QUEUE,PRE()                           ! 
S                    CSTRING(200)                          !  
                     END                                   ! 
Window               WINDOW(' '),AT(,,407,273),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY,MDI, |
  SYSTEM
                       ENTRY(@s255),AT(31,8,348,14),USE(FileName)
                       BUTTON('...'),AT(383,10,12,12),USE(?LookupFile)
                       TEXT,AT(11,28,384,98),USE(PythonProgram),FONT('Arial',10,,FONT:regular,CHARSET:CYRILLIC),HVSCROLL
                       BUTTON(''),AT(347,138,52,14),USE(?Button2)
                       BUTTON(''),AT(349,254,49,13),USE(?Close)
                       LIST,AT(11,138,326,89),USE(?List1),VSCROLL,FORMAT('796L(2)|M~~C@s199@'),FROM(Text)
                       PROMPT(''),AT(3,8),USE(?Prompt1)
                       STRING(@s60),AT(41,232,246),USE(Loc:Message),FONT(,,COLOR:Red)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
FileLookup1          SelectFileClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('ParseText')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?FileName
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('ParseText',Window)                         ! Restore window settings from non-volatile store
  FileLookup1.Init
  FileLookup1.ClearOnCancel = True
  FileLookup1.Flags=BOR(FileLookup1.Flags,FILE:LongName)   ! Allow long filenames
  FileLookup1.SetMask('','*.*')                         ! Set the file mask
  FileLookup1.WindowTitle='  '
  SELF.SetAlerts()
     CS.LoadFromFile('file.py')
     PythonProgram=Cs.S
     Display()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('ParseText',Window)                      ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LookupFile
      ThisWindow.Update()
      FileName = FileLookup1.Ask(0)
      DISPLAY
    OF ?Button2
      ThisWindow.Update()
          P.Set('filename',P._String(FileName))
          IF ~P.Evaluate(PythonProgram)
            P.Get('Text',Text)
            P.Get('filename',Loc:FileName) 
          ELSE 
            Message(P.Error())
          END 
          display() 
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!!  -
!!! </summary>
GetUrl PROCEDURE 

CS                   Cstr
P                    CLASS(PyClass)                        ! 
                     END                                   ! 
Status               CSTRING(32)                           !  
Encoding             CSTRING(32)                           ! 
Url                  CSTRING(200)                          ! Url
Doc                  CSTRING(65535)                        ! 
PythonProgram        CSTRING(1000)                         ! 
Window               WINDOW(' -'),AT(,,407,273),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY, |
  MDI,SYSTEM
                       PROMPT('URL'),AT(11,12),USE(?Url:Prompt)
                       ENTRY(@s199),AT(31,9,346,12),USE(Url),MSG('Url'),TIP('Url')
                       TEXT,AT(12,40,384,86),USE(PythonProgram),FONT('Fixedsys',10,,FONT:regular,CHARSET:CYRILLIC), |
  BOXED
                       PROMPT(':'),AT(114,133),USE(?Prompt1)
                       TEXT,AT(16,148,324,122),USE(Doc),HVSCROLL,BOXED
                       BUTTON(''),AT(348,130,52,14),USE(?Button2)
                       BUTTON(''),AT(349,254,49,13),USE(?Close)
                       STRING(@s31),AT(30,26,75,10),USE(Status)
                       STRING(@s31),AT(114,25,146,11),USE(Encoding)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('GetUrl')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Url:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  URL = 'http://ya.ru' 
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('GetUrl',Window)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
     CS.LoadFromFile('url.py')
     PythonProgram=Cs.S
     Display()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('GetUrl',Window)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Button2
      ThisWindow.Update()
          P.Set('Url',P._String(Url))
          IF ~P.Evaluate(PythonProgram)
             P.Get('status',Status)
             P.Get('encoding',Encoding)    
             P.Get('HTML',Doc)
          ELSE 
             Message(P.Error()) 
          END 
          Display()
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

